NAME = libbacktrace
SOURCES = \
          Backtrace.cpp \
          BacktraceCurrent.cpp \
          BacktraceMap.cpp \
          BacktracePtrace.cpp \
          ThreadEntry.cpp \
          UnwindMap.cpp \
          UnwindStack.cpp \
          UnwindStackMap.cpp \

demangle_srcs = demangle/Demangler.cpp

CSOURCES = $(foreach source, $(filter %.c, $(SOURCES)), libbacktrace/$(source))
CXXSOURCES = $(foreach source, $(filter %.cpp, $(SOURCES)), libbacktrace/$(source)) $(demangle_srcs)
COBJECTS = $(CSOURCES:.c=.o)
CXXOBJECTS = $(CXXSOURCES:.cpp=.o)
CXXFLAGS += -c -std=gnu++17 -fno-omit-frame-pointer -fPIC
CPPFLAGS += \
            -Iinclude \
            -Ibase/include \
            -Idemangle/include \
            -Ilibprocinfo/include \
            -Ilibunwindstack/include \
            -I/usr/include/android/unwind
LDFLAGS += -shared -Wl,-soname,$(NAME).so.0 \
           -Wl,-rpath=/usr/lib/$(DEB_HOST_MULTIARCH)/android \
           -L/usr/lib/$(DEB_HOST_MULTIARCH)/android -lunwind \
           -L. -lbase -llog -lcutils -lpthread

build: $(COBJECTS) $(CXXOBJECTS)
	$(CXX) $^ -o $(NAME).so.0 $(LDFLAGS)
	ln -s $(NAME).so.0 $(NAME).so

clean:
	$(RM) $(COBJECTS) $(CXXOBJECTS) $(NAME).so*

$(CXXOBJECTS): %.o: %.cpp
	$(CXX) $< -o $@ $(CXXFLAGS) $(CPPFLAGS)

$(COBJECTS): %.o: %.c
	$(CC) $< -o $@ $(CFLAGS) $(CPPFLAGS)
